%
% plot currents
%

clear


%---------- EDIT HERE : SET OUTPUT DIRECTORY --------------%
outputdir = 'RESULTS/';
%----------------------------------------------------------%

CURRFILENAMES = {'mn','mn','loreta','lcmv', 'mc', 'vbfmri','vbmn'};
METHODS = {'mn','sloreta','loreta','lcmv', 'mc', 'vbfmri','vbmn'};
STRTITLE = {'fMRI', 'mn', 'sloreta', 'loreta', 'lcmv', 'mc', 'vbfmri', 'vbmn'};

truefile = '../TESTDATA/sbj_test.act.mat';
brainfile = '../TESTDATA/sbj_test.brain.mat';
inflate = 0;

for me = 1 : length(METHODS)
    
    currfile = [outputdir CURRFILENAMES{me} '.curr.mat'];
    
    
    switch METHODS{me}
        case {'mn','loreta','mc'}
            load(currfile);
            Jmap = abs(mean(Jact,2));
        case 'sloreta'
            load(currfile);
            Jmap = abs(mean(Jact,2));
            Jmap = Jmap ./ sqrt(Resact(:));     
        case 'lcmv'
            load(currfile);
            Jmap = abs(mean(Jact,2));
            Jmap = Jmap ./ sqrt(Varact(:));
            
        case {'vbfmri','vbmn'}
            [Jinfo,Jact] = vb_load_current(currfile);
            Jmap = abs(mean(Jact,2));
    end
    
    
    Jall(:,me) = Jmap;
    
end


% fMRI activity 
Act = vb_get_act(truefile, 'LR');
X0 = Act.xxP;

J = [X0 Jall];
for ii = 1 : size(J,2)
plot_current_on_brain(J(:,ii), brainfile, STRTITLE{ii}, inflate);
end
